{I have successively moved the names used in SAT from the rather arbitrary names it had to a more strict naming}
{scheme, with SAT in the beginning (or at least SOMEWHERE) in all routine names. Now when I finally fixed the core}
{routines, I can't demand all old SAT users to change all their code right away. I know how it is, but . This is the backwards compatibility}
{file for Pascal users.}

{To make old SAT programs (made for SAT up to 2.1.2) work without updating to the new names, do the following:}
{- Include SATold.lib in the project.}
{- Uncomment the declarations in SAT.p. Note that you can't recompile SATold.lib with SAT.p in such a state.}
{- Some names are not supported by SATold.lib, most notably colorFlag, which CAN'T be supported that way.}
{Change all references to colorFlag to gSAT.colorFlag.}

{However, if your project isn't extremely big and complext, it's just as easy to change the calls to the new}
{names.}

unit SATold;

interface
	uses
		SAT;

	function NewSprite (theKind, hpos, vpos: integer; setup: ProcPtr): SpritePtr;
	function NewSpriteAfter (afterthis: SpritePtr; theKind, hpos, vpos: integer; setup: ProcPtr): SpritePtr;

	function GetFace (ResNum: integer): FacePtr;
	procedure DisposeFace (TheFace: FacePtr);

	procedure KillSprite (who: Spriteptr);
	procedure PeekOffscreen; {Old name for SATRedraw}

	procedure ConfigureSAT (PICTfit: boolean; newSorting, newCollision, searchWidth: integer);
	procedure InitSAT (pictID, bwpictID, Xsize, Ysize: integer);
	procedure CustomInitSAT (pictID, bwpictID: integer; SATdrawingArea: Rect; {}
									preloadedWind: WindowPtr; chosenScreen: GDHandle; useMenuBar, {}
									centerDrawingArea, fillScreen, dither4bit, beSmart: Boolean);{}
	procedure SkipSAT;
	procedure KillSAT; {Dispose of offscreen buffers to allow re-init}
	procedure RunSAT (fast: Boolean);

implementation

	function NewSpriteAfter (afterthis: SpritePtr; theKind, hpos, vpos: integer; setup: ProcPtr): SpritePtr;
	begin
		NewSpriteAfter := SATNewSpritePP(afterthis, nil, theKind, hpos, vpos, setup);
	end;

	function NewSprite (theKind, hpos, vpos: integer; setup: ProcPtr): SpritePtr;
	begin
		NewSprite := SATNewSpritePP(nil, nil, theKind, hpos, vpos, setup);
	end;

	function GetFace (resNum: integer): FacePtr;
	begin
		GetFace := SATGetFace(resNum);
	end;

	procedure DisposeFace (theFace: FacePtr);
	begin
		SATDisposeFacePP(theFace);
		DisposePtr(Ptr(theFace));
	end;

	procedure KillSprite (who: SpritePtr);
	begin
		SATKillSprite(who);
	end;

{Old name for SATRedraw - kept for backwards compatibility}
	procedure PeekOffscreen;
	begin
		SATRedraw;
	end;

	procedure ConfigureSAT (PICTfit: boolean; newSorting, newCollision, searchWidth: integer);
	begin
		SATConfigure(PICTfit, newSorting, newCollision, searchWidth);
	end;
	procedure InitSAT (pictID, bwpictID, Xsize, Ysize: integer);
	begin
	end;
	procedure CustomInitSAT (pictID, bwpictID: integer; SATdrawingArea: Rect; {}
									preloadedWind: WindowPtr; chosenScreen: GDHandle; useMenuBar, {}
									centerDrawingArea, fillScreen, dither4bit, beSmart: Boolean);{}
	begin
		SATCustomInit(pictID, bwpictID, SATdrawingArea, preloadedWind, chosenScreen, useMenuBar, centerDrawingArea, fillScreen, dither4bit, beSmart);{}
	end;
	procedure SkipSAT;
	begin
		SATSkip;
	end;
	procedure KillSAT; {Dispose of offscreen buffers to allow re-init}
	begin
		SATKill;
	end;
	procedure RunSAT (fast: Boolean);
	begin
		SATRun(fast);
	end;

end.